Kerbal Space Program - Bug #6720

Changing root in ships with multiple Pods causes malformed subassembly when merging
01/17/2016 01:34 AM - kobrakiller
Description

Changing root in a subassembly with multiple pods to any other pod causes odd behavior when merging with another craft.

Steps to reproduce:

Create new craft in VAB

Select a Pod category part as original root
(Optional)Place intervening equipment

Place another Pod category part

Change root to the second Pod category part
Save

Load or start new craft

Merge the first craft as a subassembly

Expected:
Selected root of saved subassembly is anchored to cursor for placement on the main assembly craft

Observed:

The original root is stuck to the cursor while the new root and other attached parts is embedded somewhere on the craft. The original
root may be placed anywhere in space, but acts as the root of the main assembly craft when selected. The subassembly root can
then be placed as normal, but moving the original root by relative offset. The original root can exist off in empty space, anchored by
relation to the craft but otherwise affecting physics as if it existed physically attached to the craft.

Workaround:
(Re)Build subassembly without changing root.

Notes:
Merging crafts without multiple pods that has had root changed has similar issues where the original root is stuck to cursor, but major
broken behavior of existing off in space only occurs when it has been changed from pod to pod.

Other files:
Screenshots (modded version shown, but bug tested and confirmed with mods deactivated): http://imgur.com/a/dT60I

History

#1-01/18/2016 12:01 AM - Kasuha

| think it needs to be stressed that this is about Merge operation from saved crafts, not about subassemblies.

| made a few experiments along the suggested lines and found the condition to be even simpler: Merge fails when the root part of the merged craft is
not its first part.

Any parts that are parents to the first part in the ship structure are placed to their original VAB/SPH positions, any parts to which the first part is parent
are dragged together with it. It is as if the craft is loaded, then the game "clicks" on the first part instead of root.

Start a new craft, select root part (any part that can be selected as root; | tested it with fuel tank)
Attach another part

Select the second part as root (but do not detach them from each other)

Save the ship

Move the ship slightly

Merge the saved ship
http://imgur.com/a/dT60I

Workaround: after selecting new root, detach its orignal parent structure (whatever was between it and the original root) and attach it again. That will
make it the first part in the craft and it will be possible to merge it.

#2 - 07/17/2016 09:43 AM - TriggerAu

- Status changed from New to Needs Clarification

Files
Root of the Problem.craft 20.1 KB 01/17/2016 kobrakiller
Merged Root.craft 84.9 KB 01/17/2016 kobrakiller
